unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ScktComp, StdCtrls, Menus, ExtCtrls;

const nic=999;

type
  TLevel = record
    dir:integer;  // 0 = nic; 1 = dolu; -1 = nahoru
  end;
  TPass = record
    id:integer;
    starttime,backtime,blocktime:cardinal;
    start,stop:integer;
  end;
  TShaft = record
    destfloor,pos,speed,floor:integer;
    open:boolean;
    dir:integer;
    dests:array of integer;

  end;
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    View1: TMenuItem;
    Special1: TMenuItem;
    Connect1: TMenuItem;
    Commandline1: TMenuItem;
    log: TListBox;
    Con: TClientSocket;
    Memo1: TMemo;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    procedure Connect1Click(Sender: TObject);
    procedure ConConnect(Sender: TObject; Socket: TCustomWinSocket);
    procedure Commandline1Click(Sender: TObject);
    procedure ConRead(Sender: TObject; Socket: TCustomWinSocket);
    procedure ConError(Sender: TObject; Socket: TCustomWinSocket;
      ErrorEvent: TErrorEvent; var ErrorCode: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    gcom:string;
    levelh,maxboard,maxdev,maxspeed,maxaccel:integer;
    levels:array of TLevel;
    runengine:boolean;
    passengers:array of TPass;
    shafts:array of TShaft;
    procedure Engine;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Engine;
var
p,kam,i,j:integer;
begin
  for i:=0 to Length(shafts)-1 do begin
    if shafts[i].dir=-1 then begin // pokud jede dolu a nekdo tim smerem chce taky dolu, tak ho vem
      for j:=shafts[i].floor-1 downto 0 do if levels[j].dir=-1 then begin
        setlength(shafts[i].dests,length(shafts[i].dests)+1);
        shafts[i].dests[length(shafts[i].dests)-1]:=j;
        shafts[i].dir:=0;
        break;
      end;
    end;
    if shafts[i].dir=1 then begin // pokud jede nahoru a nekdo tim smerem chce taky nahoru, tak ho vem
      for j:=shafts[i].floor to length(levels)-1 do if levels[j].dir=1 then begin
        setlength(shafts[i].dests,length(shafts[i].dests)+1);
        shafts[i].dests[length(shafts[i].dests)-1]:=j;
        shafts[i].dir:=0;
        break;
      end;
    end;

    if shafts[i].dir=0 then begin
      if length(shafts[i].dests)>0 then begin
        if shafts[i].open then con.Socket.SendText('close '+inttostr(i)+#13#10) else begin
          kam:=shafts[i].dests[0];
          p:=0;
          for j:=1 to length(shafts[i].dests)-1 do if abs(kam-shafts[i].floor)>abs(shafts[i].floor-shafts[i].dests[j]) then begin
            kam:=shafts[i].dests[j];
            p:=j;
          end;
          for j:=p to length(shafts[i].dests)-2 do shafts[i].dests[j]:=shafts[i].dests[j+1];
          setlength(shafts[i].dests,length(shafts[i].dests)-1);
          if kam>shafts[i].floor then shafts[i].dir:=1 else shafts[i].dir:=-1;
          shafts[i].destfloor:=kam;
        end;
      end else begin
        for j:=0 to Length(levels)-1 do if levels[j].dir<>0 then begin
          shafts[i].destfloor:=j;
          kam:=j;
          if kam>shafts[i].floor then shafts[i].dir:=1 else shafts[i].dir:=-1;
          levels[j].dir:=0;
          break;
        end;
      end;
    end;
    if shafts[i].dir<>0 then begin
      if shafts[i].floor=shafts[i].destfloor then begin
        shafts[i].dir:=0;
        levels[shafts[i].floor].dir:=0;
        con.Socket.SendText('indiupoff '+inttostr(shafts[i].floor)+#13#10+'indidnoff '+inttostr(shafts[i].floor)+#13#10+'indioff '+inttostr(i)+' '+inttostr(shafts[i].destfloor)+#13#10+'open '+inttostr(i)+#13#10);
//        if levels[shafts[i].destfloor].dir=-1 then  con.Socket.SendText('indiupon '+inttostr(shafts[i].destfloor)+#13#10);
        shafts[i].destfloor:=0;
      end else begin
        shafts[i].floor:=shafts[i].floor+shafts[i].dir;

        con.Socket.SendText('floor '+inttostr(i)+' '+inttostr(shafts[i].floor)+#13#10);
      end;
    end;
  end;
end;

procedure TForm1.Connect1Click(Sender: TObject);
var
host,conhost:string;
port:word;
begin
  conhost:=InputBox('Adresa pro spojen','Zadejte adresu pro spojen a slo portu:','localhost:5438');
  if pos(':',conhost)=0 then begin
    showmessage('Nebyl zadn port pro pipojen! Bude pouit 5438.');
    port:=5438;
    host:=conhost;
  end else begin
    host:=copy(conhost,1,pos(':',conhost)-1);
    delete(conhost,1,pos(':',conhost));
    port:=strtoint(conhost);
  end;
  con.Host:=host;
  con.Port:=port;
  try
    con.open;
  except
    log.Items.Add('Nepodailo se pipojit k serveru!');
  end;
end;

procedure TForm1.ConConnect(Sender: TObject; Socket: TCustomWinSocket);
begin
  log.Items.add('Connected');
  con.Socket.SendText('param'#13#10);
  runengine:=true;
end;

procedure TForm1.Commandline1Click(Sender: TObject);
var
cmd:string;
begin
  if con.Active then begin
    cmd:=InputBox('Pkazov dka','Zadejte pkaz pro odesln:','');
    con.Socket.SendText(cmd);
  end else showmessage('Klient nen pipojen!');
end;

procedure TForm1.ConRead(Sender: TObject; Socket: TCustomWinSocket);
var
gcom,com:string;
params:array of string;
i:integer;
begin
  gcom:=gcom+socket.ReceiveText;

  while (length(gcom)>0) and (pos(#13#10,gcom)>0) do begin
    com:=copy(gcom,1,pos(#13#10,gcom)-1);
    delete(gcom,1,pos(#13#10,gcom)+1);
    memo1.Lines.add(com);
    params:=nil;
    while (length(com)>0) or (pos(' ',com)>0) do begin
      setlength(params,length(params)+1);
      if pos(' ',com)>0 then begin
        params[length(params)-1]:=copy(com,1,pos(' ',com)-1);
        delete(com,1,pos(' ',com));
      end else begin
        params[length(params)-1]:=com;
        com:='';
      end;
    end;
    if length(params)=0 then exit;
    if lowercase(params[0])='shafts' then begin
       setlength(shafts,strtoint(params[1]));
       for i:=0 to length(shafts)-1 do begin
         shafts[i].open:=false;
         shafts[i].dir:=0;
       end;
    end;
    if lowercase(params[0])='levels' then setlength(levels,strtoint(params[1]));
    if lowercase(params[0])='levelheight' then levelh:=strtoint(params[1]);
    if lowercase(params[0])='maxonboard' then maxboard:=strtoint(params[1]);
    if lowercase(params[0])='maxdev' then maxdev:=strtoint(params[1]);
    if lowercase(params[0])='maxspeed' then maxspeed:=strtoint(params[1]);
    if lowercase(params[0])='maxaccel' then maxaccel:=strtoint(params[1]);
    if lowercase(params[0])='level' then begin
      shafts[strtoint(params[1])].floor:=strtoint(params[2]);
//      con.Socket.SendText('shaftinfo '+params[1]+' '+params[2]);
    end;
    if lowercase(params[0])='meter' then shafts[strtoint(params[1])].pos:=strtoint(params[2]);
    if lowercase(params[0])='cabinbutton' then begin
      setlength(shafts[strtoint(params[1])].dests,length(shafts[strtoint(params[1])].dests)+1);
      shafts[strtoint(params[1])].dests[length(shafts[strtoint(params[1])].dests)-1]:=strtoint(params[2]);
      con.Socket.SendText('indion '+params[1]+' '+params[2]+#13#10);
    end;
    if lowercase(params[0])='levelbuttonup' then begin
      levels[strtoint(params[1])].dir:=1;
      con.Socket.SendText('indiupon '+params[1]+#13#10);
    end;
    if lowercase(params[0])='levelbuttondn' then begin
      levels[strtoint(params[1])].dir:=-1;
      con.Socket.SendText('indidnon '+params[1]+#13#10);
    end;
    if lowercase(params[0])='newpas' then begin
      setlength(passengers,length(passengers)+1);
      with passengers[length(passengers)-1] do begin
        id:=strtoint(params[1]);
        start:=strtoint(params[2]);
        stop:=strtoint(params[3]);
        starttime:=strtoint(params[4]);
        blocktime:=strtoint(params[5]);
        backtime:=strtoint(params[6]);
      end;
    end;
    if lowercase(params[0])='opened' then shafts[strtoint(params[1])].open:=true;
    if lowercase(params[0])='closed' then shafts[strtoint(params[1])].open:=false;
  end;
 if runengine then engine;


end;

procedure TForm1.ConError(Sender: TObject; Socket: TCustomWinSocket;
  ErrorEvent: TErrorEvent; var ErrorCode: Integer);
begin
  log.Items.add('Chyba v komunikaci!');
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Con.Close;
  passengers:=nil;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  runengine:=false;
end;

end.
